<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: /home/mohamed/code/tigl/src/standard/communication/tiglCommunicationMutationMessage.hpp Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Classes</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.html"><span>File&#160;List</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li><li class="navelem"><a class="el" href="dir_512e97a87e29490d503e7e4403f25482.html">standard</a></li><li class="navelem"><a class="el" href="dir_8ae10044201bd9cdcbde8114bcd40f55.html">communication</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">tiglCommunicationMutationMessage.hpp</div>  </div>
</div><!--header-->
<div class="contents">
<a href="tiglCommunicationMutationMessage_8hpp.html">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div>
<div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * tiglCommunicationMutationMessage.hpp</span></div>
<div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div>
<div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> *  Created on: Oct 15, 2014</span></div>
<div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *      Author: root</span></div>
<div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> */</span></div>
<div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;</div>
<div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#ifndef TIGLCOMMUNICATIONMUTATIONMESSAGE_HPP_</span></div>
<div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="preprocessor">#define TIGLCOMMUNICATIONMUTATIONMESSAGE_HPP_</span></div>
<div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;</div>
<div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;</div>
<div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;</div>
<div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="preprocessor">#include &lt;types.h&gt;</span></div>
<div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="preprocessor">#include &lt;algorithm&gt;</span></div>
<div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &lt;vector&gt;</span></div>
<div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;</div>
<div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;<span class="keyword">typedef</span> <span class="keyword">enum</span></div>
<div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;{</div>
<div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;    ADD_VERTEX = 0, </div>
<div class="line"><a name="l00029"></a><span class="lineno">   29</span>&#160;    MIGRATE_VERTEX, </div>
<div class="line"><a name="l00030"></a><span class="lineno">   30</span>&#160;    ADD_EMPTY_VERTEX, </div>
<div class="line"><a name="l00031"></a><span class="lineno">   31</span>&#160;    REMOVE_VERTEX, </div>
<div class="line"><a name="l00032"></a><span class="lineno">   32</span>&#160;    ADD_OUT_EDGE, </div>
<div class="line"><a name="l00033"></a><span class="lineno">   33</span>&#160;    ADD_IN_EDGE, </div>
<div class="line"><a name="l00034"></a><span class="lineno">   34</span>&#160;    REMOVE_OUT_EDGE, </div>
<div class="line"><a name="l00035"></a><span class="lineno">   35</span>&#160;    REMOVE_IN_EDGE, </div>
<div class="line"><a name="l00036"></a><span class="lineno">   36</span>&#160;    UNDEFINED_MUTATION_MESSAGE</div>
<div class="line"><a name="l00037"></a><span class="lineno">   37</span>&#160;}MUTATION_MESSAGE_CODE;</div>
<div class="line"><a name="l00038"></a><span class="lineno">   38</span>&#160;</div>
<div class="line"><a name="l00039"></a><span class="lineno">   39</span>&#160;</div>
<div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;<span class="comment">//--------------------------------------------------------------------------------------------------------------------------------------</span></div>
<div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;</div>
<div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;<span class="keyword">using namespace </span>std;</div>
<div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;</div>
<div class="line"><a name="l00053"></a><span class="lineno"><a class="line" href="classMutationMessage.html">   53</a></span>&#160;<span class="keyword">class </span><a class="code" href="classMutationMessage.html">TIGLMutationMessage</a></div>
<div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;{</div>
<div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">typedef</span> vector&lt;byte&gt;:: iterator     BYTE_ITERATOR;</div>
<div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    <span class="comment">// constructor/destructor</span></div>
<div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00065"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a21f10b086de910f00d8d4466ff8d9478">   65</a></span>&#160;    <a class="code" href="classMutationMessage.html#a21f10b086de910f00d8d4466ff8d9478">TIGLMutationMessage</a>()</div>
<div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    {</div>
<div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;        messageCode = UNDEFINED_MUTATION_MESSAGE;</div>
<div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    }</div>
<div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <a class="code" href="classMutationMessage.html">TIGLMutationMessage</a>(MUTATION_MESSAGE_CODE code, int32 dev){</div>
<div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;        messageCode = code;</div>
<div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;        otherDevice = dev;</div>
<div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    }</div>
<div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> ObjType, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <a class="code" href="classMutationMessage.html">TIGLMutationMessage</a>(MUTATION_MESSAGE_CODE code, int32 dev, ObjType * message, ID_TYPE * targetVertex = 0)</div>
<div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    {</div>
<div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;        messageCode = code;</div>
<div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;        otherDevice = dev;</div>
<div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;</div>
<div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;        <span class="keywordflow">switch</span>(code){</div>
<div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keywordflow">case</span> ADD_EMPTY_VERTEX:</div>
<div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;        <span class="keywordflow">case</span> REMOVE_VERTEX:</div>
<div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;            prepareEmptyVertexMessage(message);</div>
<div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;        <span class="keywordflow">case</span> ADD_VERTEX:</div>
<div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;            prepareAddVertexMessage(message);</div>
<div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;        <span class="keywordflow">case</span> MIGRATE_VERTEX:</div>
<div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;            prepareMigrateVertexMessage(message);</div>
<div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;        <span class="keywordflow">case</span> ADD_OUT_EDGE:</div>
<div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;        <span class="keywordflow">case</span> ADD_IN_EDGE:</div>
<div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;            prepareAddEdgeMessage(message, targetVertex);</div>
<div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="keywordflow">case</span> REMOVE_OUT_EDGE:</div>
<div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;        <span class="keywordflow">case</span> REMOVE_IN_EDGE:</div>
<div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            prepareRemoveEdgeMessage(message, targetVertex);</div>
<div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;            <span class="keywordflow">break</span>;</div>
<div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;        }</div>
<div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    }</div>
<div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;</div>
<div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    ~<a class="code" href="classMutationMessage.html">TIGLMutationMessage</a>(){}</div>
<div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;</div>
<div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00108"></a><span class="lineno"><a class="line" href="classMutationMessage.html#acdce3bb6d07d5b7fe2895c3858137a14">  108</a></span>&#160;<span class="comment"></span>    MUTATION_MESSAGE_CODE       <a class="code" href="classMutationMessage.html#acdce3bb6d07d5b7fe2895c3858137a14">messageCode</a>;</div>
<div class="line"><a name="l00110"></a><span class="lineno"><a class="line" href="classMutationMessage.html#aa873f4348060f3b98b4a6048f6b81983">  110</a></span>&#160;    vector&lt;byte&gt;            <a class="code" href="classMutationMessage.html#aa873f4348060f3b98b4a6048f6b81983">messageBody</a>;</div>
<div class="line"><a name="l00112"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a1fce3cb22d79b08b2af417017ded07da">  112</a></span>&#160;    uint32                  <a class="code" href="classMutationMessage.html#a1fce3cb22d79b08b2af417017ded07da">otherDevice</a>;</div>
<div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;</div>
<div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;<span class="keyword">protected</span>:</div>
<div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00121"></a><span class="lineno"><a class="line" href="classMutationMessage.html#ad1fd34459df13e8162a4967d961b2cea">  121</a></span>&#160;    uint32 <a class="code" href="classMutationMessage.html#ad1fd34459df13e8162a4967d961b2cea">prepareAddEdgeMessage</a>(EdgeType * pEdge, ID_TYPE * targetVertex)</div>
<div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    {</div>
<div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;        byte * p = (byte *)targetVertex;</div>
<div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(ID_TYPE), messageBody.begin());</div>
<div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;        p = (byte *)pEdge;</div>
<div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(EdgeType), messageBody.end());</div>
<div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;        <span class="keywordflow">return</span> messageBody.size()+1; <span class="comment">// one byte is added for the message code</span></div>
<div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    }</div>
<div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;</div>
<div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;<span class="comment"></span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> EdgeType, <span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00135"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a1b6e1b5ce4c29e252a839bb7d28b2bc5">  135</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classMutationMessage.html#a1b6e1b5ce4c29e252a839bb7d28b2bc5">readAddEdgeMessage</a>(EdgeType * pEdge, ID_TYPE * targetVertex)</div>
<div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    {</div>
<div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;        <span class="keywordflow">if</span>(messageBody.size() != <span class="keyword">sizeof</span>(EdgeType)+<span class="keyword">sizeof</span>(ID_TYPE))</div>
<div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;</div>
<div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;        byte * p = (byte *)&amp;targetVertex;</div>
<div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;        std::copy(messageBody.begin(), messageBody.begin()+<span class="keyword">sizeof</span>(ID_TYPE), p);</div>
<div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        p = (byte *)pEdge;</div>
<div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        std::copy(messageBody.begin()+<span class="keyword">sizeof</span>(ID_TYPE), messageBody.end(), p);</div>
<div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    }</div>
<div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;<span class="comment"></span></div>
<div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00153"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a4dd11e68c90db1b6c2752be8c723b128">  153</a></span>&#160;    uint32 <a class="code" href="classMutationMessage.html#a4dd11e68c90db1b6c2752be8c723b128">prepareRemoveEdgeMessage</a>(ID_TYPE * nbrVertex, ID_TYPE * targetVertex)</div>
<div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    {</div>
<div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        byte * p = (byte *)targetVertex;</div>
<div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(ID_TYPE), messageBody.begin());</div>
<div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;        p = (byte *)nbrVertex;</div>
<div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(ID_TYPE), messageBody.end());</div>
<div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;        <span class="keywordflow">return</span> messageBody.size()+1; <span class="comment">// one byte is added for the message code</span></div>
<div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    }</div>
<div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;</div>
<div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;<span class="comment"></span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00168"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a588b2459d4dd50217a6451af8802e88d">  168</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classMutationMessage.html#a588b2459d4dd50217a6451af8802e88d">readRemoveEdgeMessage</a>(ID_TYPE * nbrVertex, ID_TYPE * targetVertex)</div>
<div class="line"><a name="l00169"></a><span class="lineno">  169</span>&#160;    {</div>
<div class="line"><a name="l00170"></a><span class="lineno">  170</span>&#160;        <span class="keywordflow">if</span>(messageBody.size() != 2*<span class="keyword">sizeof</span>(ID_TYPE))</div>
<div class="line"><a name="l00171"></a><span class="lineno">  171</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00172"></a><span class="lineno">  172</span>&#160;</div>
<div class="line"><a name="l00173"></a><span class="lineno">  173</span>&#160;        byte * p = (byte *)&amp;targetVertex;</div>
<div class="line"><a name="l00174"></a><span class="lineno">  174</span>&#160;        std::copy(messageBody.begin(), messageBody.begin()+<span class="keyword">sizeof</span>(ID_TYPE), p);</div>
<div class="line"><a name="l00175"></a><span class="lineno">  175</span>&#160;        p = (byte *)nbrVertex;</div>
<div class="line"><a name="l00176"></a><span class="lineno">  176</span>&#160;        std::copy(messageBody.begin()+<span class="keyword">sizeof</span>(ID_TYPE), messageBody.end(), p);</div>
<div class="line"><a name="l00177"></a><span class="lineno">  177</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00178"></a><span class="lineno">  178</span>&#160;    }</div>
<div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;<span class="comment"></span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00184"></a><span class="lineno"><a class="line" href="classMutationMessage.html#acd878d994f3305730548ff6b37d72d89">  184</a></span>&#160;    uint32 <a class="code" href="classMutationMessage.html#acd878d994f3305730548ff6b37d72d89">prepareEmptyVertexMessage</a>(ID_TYPE * vertexId)</div>
<div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    {</div>
<div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;        byte * p = (byte *)vertexId;</div>
<div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(ID_TYPE), messageBody.begin());</div>
<div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;</div>
<div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;        <span class="keywordflow">return</span> messageBody.size()+1; <span class="comment">// one byte is added for the message code</span></div>
<div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    }</div>
<div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;</div>
<div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;<span class="comment"></span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00197"></a><span class="lineno"><a class="line" href="classMutationMessage.html#abbd3fa9e6726c2f833d1713a985affc4">  197</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classMutationMessage.html#abbd3fa9e6726c2f833d1713a985affc4">readEmptyVertexMessage</a>(ID_TYPE * vertexId)</div>
<div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    {</div>
<div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;        <span class="keywordflow">if</span>(messageBody.size() != <span class="keyword">sizeof</span>(ID_TYPE))</div>
<div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;        byte * p = (byte *)vertexId;</div>
<div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;        std::copy(messageBody.begin(), messageBody.end(), p);</div>
<div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;</div>
<div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;    }</div>
<div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;<span class="comment"></span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><a name="l00212"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a40df23bd34b66d1ecdd91ca0da74b981">  212</a></span>&#160;    uint32 <a class="code" href="classMutationMessage.html#a40df23bd34b66d1ecdd91ca0da74b981">prepareAddVertexMessage</a>(CVertex * vertex)</div>
<div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    {</div>
<div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::ID_TYPE               ID_TYPE;</div>
<div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::OUT_EDGE_ITERATOR     OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::OUT_EDGE_BUF          OUT_EDGE_BUF;</div>
<div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::EDGE_TYPE             EDGE_TYPE;</div>
<div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::OUT_EDGE_ITERATOR     EDGE_ITERATOR;</div>
<div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::AlgDataType           ALG_DATA_TYPE;</div>
<div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::DATA_TYPE             DATA_TYPE;</div>
<div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;</div>
<div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;</div>
<div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;        <span class="comment">// adding the objecte information</span></div>
<div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;        ID_TYPE <span class="keywordtype">id</span> = vertex-&gt;getId();</div>
<div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;        byte * p = (byte *)<span class="keywordtype">id</span>;</div>
<div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(ID_TYPE), messageBody.begin());</div>
<div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;</div>
<div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;        <span class="comment">// adding vertexData information</span></div>
<div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        DATA_TYPE vertexData = vertex-&gt;get_value();</div>
<div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;        p = (byte *)&amp;vertexData;</div>
<div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(DATA_TYPE), messageBody.end());</div>
<div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;</div>
<div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;        <span class="comment">// adding algData information</span></div>
<div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;        ALG_DATA_TYPE algData = vertex-&gt;getAlgData();</div>
<div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;        p = (byte *)&amp;algData;</div>
<div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(ALG_DATA_TYPE), messageBody.end());</div>
<div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;</div>
<div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;        <span class="comment">// finally adding edge information</span></div>
<div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;        <span class="comment">// adding number of output edges</span></div>
<div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;        uint32 numEdges = vertex-&gt;get_num_out_edges();</div>
<div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        p = (byte *)&amp;numEdges;</div>
<div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(uint32), messageBody.end());</div>
<div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;</div>
<div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="keywordflow">for</span>(OUT_EDGE_ITERATOR it = vertex-&gt;get_out_edge_iterator();</div>
<div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;                    it != vertex-&gt;get_end_out_edge_iterator(); ++it)</div>
<div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        {</div>
<div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;            EDGE_TYPE edge = *it;</div>
<div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;            p = (byte *)&amp;edge;</div>
<div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;            std::copy(p, p+<span class="keyword">sizeof</span>(EDGE_TYPE), messageBody.end());</div>
<div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;        }</div>
<div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;        <span class="comment">// checking if it has input edge buffer</span></div>
<div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;        <span class="keywordflow">if</span>(vertex-&gt;is_bivertex())</div>
<div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;        {</div>
<div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;            uint32 numInEdges = vertex-&gt;get_num_in_edges();</div>
<div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;            p = (byte *)&amp;numInEdges;</div>
<div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;            std::copy(p, p+<span class="keyword">sizeof</span>(uint32), messageBody.end());</div>
<div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;</div>
<div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;            <span class="keywordflow">for</span>(EDGE_ITERATOR it = vertex-&gt;get_in_edge_iterator();</div>
<div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;                    it != vertex-&gt;get_end_in_edge_iterator(); ++it)</div>
<div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;            {</div>
<div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;                EDGE_TYPE edge = *it;</div>
<div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;                p = (byte *)&amp;edge;</div>
<div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;                std::copy(p, p+<span class="keyword">sizeof</span>(EDGE_TYPE), messageBody.end());</div>
<div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;            }</div>
<div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;        }</div>
<div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;        <span class="keywordflow">return</span> messageBody.size()+1; <span class="comment">// one byte is added for the message code</span></div>
<div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    }</div>
<div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;</div>
<div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;<span class="comment"></span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><a name="l00274"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a85a9603c0995c954654db90b6e3c753d">  274</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classMutationMessage.html#a85a9603c0995c954654db90b6e3c753d">readAddVertexMessage</a>(CVertex * pVertex)</div>
<div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    {</div>
<div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::ID_TYPE               ID_TYPE;</div>
<div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::OUT_EDGE_ITERATOR     OUT_EDGE_ITERATOR;</div>
<div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::OUT_EDGE_BUF          OUT_EDGE_BUF;</div>
<div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::EDGE_TYPE             EDGE_TYPE;</div>
<div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::OUT_EDGE_ITERATOR     EDGE_ITERATOR;</div>
<div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::AlgDataType           ALG_DATA_TYPE;</div>
<div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::DATA_TYPE             DATA_TYPE;</div>
<div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;</div>
<div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;</div>
<div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;        uint32 index;</div>
<div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;        <span class="comment">// adding the objecte information</span></div>
<div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;        ID_TYPE id;</div>
<div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;        byte * p = (byte *)<span class="keywordtype">id</span>;</div>
<div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;        BYTE_ITERATOR it = messageBody.begin();</div>
<div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;        BYTE_ITERATOR itBound = it+<span class="keyword">sizeof</span>(ID_TYPE);</div>
<div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;        <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;        std::copy(it, itBound, p);</div>
<div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;</div>
<div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;        <span class="comment">// adding vertexData information</span></div>
<div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;        DATA_TYPE vertexData;</div>
<div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;        p = (byte *)&amp;vertexData;</div>
<div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;        it = itBound;</div>
<div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;        itBound += <span class="keyword">sizeof</span>(DATA_TYPE);</div>
<div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;        <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;        std::copy(it, itBound, p);</div>
<div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;</div>
<div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;        <span class="comment">// adding algData information</span></div>
<div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;        ALG_DATA_TYPE algData;</div>
<div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;        p = (byte *)&amp;algData;</div>
<div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;        it = itBound;</div>
<div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;        itBound += <span class="keyword">sizeof</span>(ALG_DATA_TYPE);</div>
<div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;        <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;        std::copy(it, itBound, p);</div>
<div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;</div>
<div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;        pVertex-&gt;setParams(<span class="keywordtype">id</span>, vertexData, algData);</div>
<div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;</div>
<div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;</div>
<div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;        <span class="comment">// finally adding edge information</span></div>
<div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;        <span class="comment">// adding number of output edges</span></div>
<div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;        uint32 numEdges;</div>
<div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;        p = (byte *)&amp;numEdges;</div>
<div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;        it = itBound;</div>
<div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;        itBound += <span class="keyword">sizeof</span>(uint32);</div>
<div class="line"><a name="l00322"></a><span class="lineno">  322</span>&#160;        <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00323"></a><span class="lineno">  323</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00324"></a><span class="lineno">  324</span>&#160;        std::copy(it, itBound, p);</div>
<div class="line"><a name="l00325"></a><span class="lineno">  325</span>&#160;</div>
<div class="line"><a name="l00326"></a><span class="lineno">  326</span>&#160;</div>
<div class="line"><a name="l00327"></a><span class="lineno">  327</span>&#160;        <span class="keywordflow">for</span>(uint32 i = 0; i &lt; numEdges; i++)</div>
<div class="line"><a name="l00328"></a><span class="lineno">  328</span>&#160;        {</div>
<div class="line"><a name="l00329"></a><span class="lineno">  329</span>&#160;            EDGE_TYPE edge;</div>
<div class="line"><a name="l00330"></a><span class="lineno">  330</span>&#160;            p = (byte *)&amp;edge;</div>
<div class="line"><a name="l00331"></a><span class="lineno">  331</span>&#160;            it = itBound;</div>
<div class="line"><a name="l00332"></a><span class="lineno">  332</span>&#160;            itBound += <span class="keyword">sizeof</span>(EDGE_TYPE);</div>
<div class="line"><a name="l00333"></a><span class="lineno">  333</span>&#160;            <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00334"></a><span class="lineno">  334</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00335"></a><span class="lineno">  335</span>&#160;            std::copy(it, itBound, p);</div>
<div class="line"><a name="l00336"></a><span class="lineno">  336</span>&#160;            pVertex-&gt;addEdge(edge);</div>
<div class="line"><a name="l00337"></a><span class="lineno">  337</span>&#160;        }</div>
<div class="line"><a name="l00338"></a><span class="lineno">  338</span>&#160;        <span class="comment">// checking if it has input edge buffer</span></div>
<div class="line"><a name="l00339"></a><span class="lineno">  339</span>&#160;        <span class="keywordflow">if</span>(pVertex-&gt;is_bivertex())</div>
<div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;        {</div>
<div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;            uint32 numInEdges ;</div>
<div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;            it = itBound;</div>
<div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;            itBound += <span class="keyword">sizeof</span>(uint32);</div>
<div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;            <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;            std::copy(it, itBound, p);</div>
<div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;</div>
<div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;            <span class="keywordflow">for</span>(uint32 i = 0; i &lt; numInEdges; i++)</div>
<div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;            {</div>
<div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;                EDGE_TYPE edge;</div>
<div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;                p = (byte *)&amp;edge;</div>
<div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;                it = itBound;</div>
<div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;                itBound += <span class="keyword">sizeof</span>(EDGE_TYPE);</div>
<div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;                <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;                    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;                std::copy(it, itBound, p);</div>
<div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;                pVertex-&gt;addInEdge(edge);</div>
<div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;            }</div>
<div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;        }</div>
<div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;</div>
<div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;    }</div>
<div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;</div>
<div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;</div>
<div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00370"></a><span class="lineno">  370</span>&#160;<span class="comment"></span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><a name="l00371"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a75164a2782ad4b29499c870ed80bb9e8">  371</a></span>&#160;    uint32 <a class="code" href="classMutationMessage.html#a75164a2782ad4b29499c870ed80bb9e8">prepareMigrateVertexMessage</a>(CVertex * vertex)</div>
<div class="line"><a name="l00372"></a><span class="lineno">  372</span>&#160;    {</div>
<div class="line"><a name="l00373"></a><span class="lineno">  373</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::EDGE_TYPE             EDGE_TYPE;</div>
<div class="line"><a name="l00374"></a><span class="lineno">  374</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::OUT_EDGE_ITERATOR     EDGE_ITERATOR;</div>
<div class="line"><a name="l00375"></a><span class="lineno">  375</span>&#160;</div>
<div class="line"><a name="l00376"></a><span class="lineno">  376</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00377"></a><span class="lineno">  377</span>&#160;</div>
<div class="line"><a name="l00378"></a><span class="lineno">  378</span>&#160;        <span class="comment">// adding the objecte information</span></div>
<div class="line"><a name="l00379"></a><span class="lineno">  379</span>&#160;        byte * p = (byte *)vertex;</div>
<div class="line"><a name="l00380"></a><span class="lineno">  380</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(CVertex), messageBody.begin());</div>
<div class="line"><a name="l00381"></a><span class="lineno">  381</span>&#160;</div>
<div class="line"><a name="l00382"></a><span class="lineno">  382</span>&#160;        <span class="comment">// finally adding edge information</span></div>
<div class="line"><a name="l00383"></a><span class="lineno">  383</span>&#160;        <span class="comment">// adding number of output edges</span></div>
<div class="line"><a name="l00384"></a><span class="lineno">  384</span>&#160;        uint32 numEdges = vertex-&gt;get_num_out_edges();</div>
<div class="line"><a name="l00385"></a><span class="lineno">  385</span>&#160;        p = (byte *)&amp;numEdges;</div>
<div class="line"><a name="l00386"></a><span class="lineno">  386</span>&#160;        std::copy(p, p+<span class="keyword">sizeof</span>(uint32), messageBody.end());</div>
<div class="line"><a name="l00387"></a><span class="lineno">  387</span>&#160;</div>
<div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;        <span class="keywordflow">for</span>(EDGE_ITERATOR it = vertex-&gt;get_out_edge_iterator();</div>
<div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;                    it != vertex-&gt;get_end_out_edge_iterator(); ++it)</div>
<div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;        {</div>
<div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;            EDGE_TYPE edge = *it;</div>
<div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;            p = (byte *)&amp;edge;</div>
<div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;            std::copy(p, p+<span class="keyword">sizeof</span>(EDGE_TYPE), messageBody.end());</div>
<div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;        }</div>
<div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;        <span class="comment">// checking if it has input edge buffer</span></div>
<div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;        <span class="keywordflow">if</span>(vertex-&gt;is_bivertex())</div>
<div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;        {</div>
<div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;            uint32 numInEdges = vertex-&gt;get_num_in_edges();</div>
<div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;            p = (byte *)&amp;numInEdges;</div>
<div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;            std::copy(p, p+<span class="keyword">sizeof</span>(uint32), messageBody.end());</div>
<div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;</div>
<div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;            <span class="keywordflow">for</span>(EDGE_ITERATOR it = vertex-&gt;get_in_edge_iterator();</div>
<div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;                    it != vertex-&gt;get_end_in_edge_iterator(); ++it)</div>
<div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;            {</div>
<div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;                EDGE_TYPE edge = *it;</div>
<div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;                p = (byte *)&amp;edge;</div>
<div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;                std::copy(p, p+<span class="keyword">sizeof</span>(EDGE_TYPE), messageBody.end());</div>
<div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;<span class="comment">//              for(uint32 i =0 ; i &lt; sizeof(EDGE_TYPE); i++)</span></div>
<div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;<span class="comment">//                  messageBody.push_back(*(p++));</span></div>
<div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;            }</div>
<div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;        }</div>
<div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;        <span class="keywordflow">return</span> messageBody.size()+1; <span class="comment">// one byte is added for the message code</span></div>
<div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    }</div>
<div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;<span class="comment"></span>    <span class="keyword">template</span>&lt;<span class="keyword">typename</span> CVertex&gt;</div>
<div class="line"><a name="l00418"></a><span class="lineno"><a class="line" href="classMutationMessage.html#aef31235623cbd56d1486f3ec62ae53fb">  418</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classMutationMessage.html#aef31235623cbd56d1486f3ec62ae53fb">readMigrateVertexMessage</a>(CVertex * pVertex)</div>
<div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;    {</div>
<div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::EDGE_TYPE             EDGE_TYPE;</div>
<div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;        <span class="keyword">typedef</span> <span class="keyword">typename</span> CVertex::OUT_EDGE_ITERATOR     EDGE_ITERATOR;</div>
<div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;</div>
<div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;</div>
<div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;        uint32 index;</div>
<div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;        <span class="comment">// adding the object information</span></div>
<div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;        BYTE_ITERATOR it = messageBody.begin();</div>
<div class="line"><a name="l00427"></a><span class="lineno">  427</span>&#160;        BYTE_ITERATOR itBound = it+<span class="keyword">sizeof</span>(CVertex);</div>
<div class="line"><a name="l00428"></a><span class="lineno">  428</span>&#160;        <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00429"></a><span class="lineno">  429</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00430"></a><span class="lineno">  430</span>&#160;        std::copy(it, itBound, (byte *)pVertex);</div>
<div class="line"><a name="l00431"></a><span class="lineno">  431</span>&#160;</div>
<div class="line"><a name="l00432"></a><span class="lineno">  432</span>&#160;        <span class="comment">// finally adding edge information</span></div>
<div class="line"><a name="l00433"></a><span class="lineno">  433</span>&#160;        <span class="comment">// adding number of output edges</span></div>
<div class="line"><a name="l00434"></a><span class="lineno">  434</span>&#160;        uint32 numEdges;</div>
<div class="line"><a name="l00435"></a><span class="lineno">  435</span>&#160;        byte * p = (byte *)&amp;numEdges;</div>
<div class="line"><a name="l00436"></a><span class="lineno">  436</span>&#160;        it = itBound;</div>
<div class="line"><a name="l00437"></a><span class="lineno">  437</span>&#160;        itBound += <span class="keyword">sizeof</span>(uint32);</div>
<div class="line"><a name="l00438"></a><span class="lineno">  438</span>&#160;        <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00439"></a><span class="lineno">  439</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00440"></a><span class="lineno">  440</span>&#160;        std::copy(it, itBound, p);</div>
<div class="line"><a name="l00441"></a><span class="lineno">  441</span>&#160;</div>
<div class="line"><a name="l00442"></a><span class="lineno">  442</span>&#160;</div>
<div class="line"><a name="l00443"></a><span class="lineno">  443</span>&#160;        <span class="keywordflow">for</span>(uint32 i = 0; i &lt; numEdges; i++)</div>
<div class="line"><a name="l00444"></a><span class="lineno">  444</span>&#160;        {</div>
<div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;            EDGE_TYPE edge;</div>
<div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;            p = (byte *)&amp;edge;</div>
<div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;            it = itBound;</div>
<div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;            itBound += <span class="keyword">sizeof</span>(EDGE_TYPE);</div>
<div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;            <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;            std::copy(it, itBound, p);</div>
<div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;            pVertex-&gt;addEdge(edge);</div>
<div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;        }</div>
<div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;        <span class="comment">// checking if it has input edge buffer</span></div>
<div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;        <span class="keywordflow">if</span>(pVertex-&gt;is_bivertex())</div>
<div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;        {</div>
<div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;            uint32 numInEdges ;</div>
<div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;            it = itBound;</div>
<div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;            itBound += <span class="keyword">sizeof</span>(uint32);</div>
<div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;            <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;                <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;            std::copy(it, itBound, p);</div>
<div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;</div>
<div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;            <span class="keywordflow">for</span>(uint32 i = 0; i &lt; numInEdges; i++)</div>
<div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;            {</div>
<div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;                EDGE_TYPE edge;</div>
<div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;                p = (byte *)&amp;edge;</div>
<div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;                it = itBound;</div>
<div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;                itBound += <span class="keyword">sizeof</span>(EDGE_TYPE);</div>
<div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;                <span class="keywordflow">if</span>(itBound == messageBody.end())</div>
<div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;                    <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;                std::copy(it, itBound, p);</div>
<div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;                pVertex-&gt;addInEdge(edge);</div>
<div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;            }</div>
<div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;        }</div>
<div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;    }</div>
<div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;</div>
<div class="line"><a name="l00480"></a><span class="lineno">  480</span>&#160;</div>
<div class="line"><a name="l00481"></a><span class="lineno">  481</span>&#160;<span class="keyword">public</span>:</div>
<div class="line"><a name="l00482"></a><span class="lineno">  482</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00484"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a2531f613fca0307804d1a4bf45e92cf5">  484</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> MUTATION_MESSAGE_CODE <a class="code" href="classMutationMessage.html#a2531f613fca0307804d1a4bf45e92cf5">getMessageCode</a>(){<span class="keywordflow">return</span> messageCode;}</div>
<div class="line"><a name="l00485"></a><span class="lineno">  485</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00487"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a1880c427af4deba4718a4d75f2f6047d">  487</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classMutationMessage.html#a1880c427af4deba4718a4d75f2f6047d">getSizeInBytes</a>(){<span class="keywordflow">return</span> messageBody.size();}</div>
<div class="line"><a name="l00488"></a><span class="lineno">  488</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00490"></a><span class="lineno"><a class="line" href="classMutationMessage.html#adbddbb20325522d31da70a102fc1511e">  490</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> int32 <a class="code" href="classMutationMessage.html#adbddbb20325522d31da70a102fc1511e">getDstDev</a>(){<span class="keywordflow">return</span> otherDevice;}</div>
<div class="line"><a name="l00491"></a><span class="lineno">  491</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00493"></a><span class="lineno">  493</span>&#160;<span class="comment"></span>    <span class="keyword">template</span> &lt;<span class="keyword">typename</span> ID_TYPE&gt;</div>
<div class="line"><a name="l00494"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a8650ccd700d60a94b9ebde4fb1ad37aa">  494</a></span>&#160;    <span class="keywordtype">bool</span> <a class="code" href="classMutationMessage.html#a8650ccd700d60a94b9ebde4fb1ad37aa">getDstVertex</a>(ID_TYPE * targetVertex){</div>
<div class="line"><a name="l00495"></a><span class="lineno">  495</span>&#160;        <span class="keywordflow">if</span>(messageCode == MIGRATE_VERTEX)</div>
<div class="line"><a name="l00496"></a><span class="lineno">  496</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00497"></a><span class="lineno">  497</span>&#160;        <span class="keywordflow">if</span>(messageCode == ADD_VERTEX)</div>
<div class="line"><a name="l00498"></a><span class="lineno">  498</span>&#160;        {</div>
<div class="line"><a name="l00499"></a><span class="lineno">  499</span>&#160;            <span class="comment">//tobe defined</span></div>
<div class="line"><a name="l00500"></a><span class="lineno">  500</span>&#160;            <span class="keywordflow">return</span> <span class="keyword">false</span>;</div>
<div class="line"><a name="l00501"></a><span class="lineno">  501</span>&#160;        }</div>
<div class="line"><a name="l00502"></a><span class="lineno">  502</span>&#160;        <span class="comment">// all other cases the target vertex is set at the beginning of the message</span></div>
<div class="line"><a name="l00503"></a><span class="lineno">  503</span>&#160;        byte * p = (byte *)targetVertex;</div>
<div class="line"><a name="l00504"></a><span class="lineno">  504</span>&#160;        std::copy(messageBody.begin(), messageBody.begin()+<span class="keyword">sizeof</span>(ID_TYPE), p);</div>
<div class="line"><a name="l00505"></a><span class="lineno">  505</span>&#160;        <span class="keywordflow">return</span> <span class="keyword">true</span>;</div>
<div class="line"><a name="l00506"></a><span class="lineno">  506</span>&#160;    }</div>
<div class="line"><a name="l00507"></a><span class="lineno">  507</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00512"></a><span class="lineno"><a class="line" href="classMutationMessage.html#a3f69431dcddd6218b390b362670f2b64">  512</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classMutationMessage.html#a3f69431dcddd6218b390b362670f2b64">pack</a>(byte * buf)</div>
<div class="line"><a name="l00513"></a><span class="lineno">  513</span>&#160;    {</div>
<div class="line"><a name="l00514"></a><span class="lineno">  514</span>&#160;        <span class="comment">// putting the message code</span></div>
<div class="line"><a name="l00515"></a><span class="lineno">  515</span>&#160;        byte firstByte = (uint8)messageCode;<span class="comment">//</span></div>
<div class="line"><a name="l00516"></a><span class="lineno">  516</span>&#160;        *(buf++) = firstByte;</div>
<div class="line"><a name="l00517"></a><span class="lineno">  517</span>&#160;        uint32 bodySize = getSizeInBytes();</div>
<div class="line"><a name="l00518"></a><span class="lineno">  518</span>&#160;        memcpy(buf, &amp;bodySize, <span class="keyword">sizeof</span>(uint32)); <span class="comment">// including the size of message body in the message header</span></div>
<div class="line"><a name="l00519"></a><span class="lineno">  519</span>&#160;        buf +=  <span class="keyword">sizeof</span>(uint32);</div>
<div class="line"><a name="l00520"></a><span class="lineno">  520</span>&#160;</div>
<div class="line"><a name="l00521"></a><span class="lineno">  521</span>&#160;        <span class="keywordflow">if</span>(bodySize)</div>
<div class="line"><a name="l00522"></a><span class="lineno">  522</span>&#160;            std::copy(messageBody.begin(), messageBody.end(), buf);</div>
<div class="line"><a name="l00523"></a><span class="lineno">  523</span>&#160;</div>
<div class="line"><a name="l00524"></a><span class="lineno">  524</span>&#160;        <span class="keywordflow">return</span> bodySize+<span class="keyword">sizeof</span>(uint32)+1; <span class="comment">// including the size (4 bytes) and the message code (1 byte)</span></div>
<div class="line"><a name="l00525"></a><span class="lineno">  525</span>&#160;    }</div>
<div class="line"><a name="l00526"></a><span class="lineno">  526</span>&#160;</div>
<div class="line"><a name="l00527"></a><span class="lineno">  527</span>&#160;    <span class="comment">//======================================================================================================</span></div>
<div class="line"><a name="l00531"></a><span class="lineno"><a class="line" href="classMutationMessage.html#ac0c615f45fa618af2f2c82009a28b71a">  531</a></span>&#160;<span class="comment"></span>    <span class="keyword">inline</span> uint32 <a class="code" href="classMutationMessage.html#ac0c615f45fa618af2f2c82009a28b71a">unpack</a>(byte * buf)</div>
<div class="line"><a name="l00532"></a><span class="lineno">  532</span>&#160;    {</div>
<div class="line"><a name="l00533"></a><span class="lineno">  533</span>&#160;        messageCode = (MUTATION_MESSAGE_CODE)(*(buf++));</div>
<div class="line"><a name="l00534"></a><span class="lineno">  534</span>&#160;        uint32 bodySize;</div>
<div class="line"><a name="l00535"></a><span class="lineno">  535</span>&#160;        memcpy(&amp;bodySize, buf, <span class="keyword">sizeof</span>(uint32));</div>
<div class="line"><a name="l00536"></a><span class="lineno">  536</span>&#160;        buf += <span class="keyword">sizeof</span>(uint32);</div>
<div class="line"><a name="l00537"></a><span class="lineno">  537</span>&#160;        messageBody.clear();</div>
<div class="line"><a name="l00538"></a><span class="lineno">  538</span>&#160;</div>
<div class="line"><a name="l00539"></a><span class="lineno">  539</span>&#160;        <span class="keywordflow">if</span>(bodySize)</div>
<div class="line"><a name="l00540"></a><span class="lineno">  540</span>&#160;            std::copy(buf, buf+bodySize, messageBody.begin());</div>
<div class="line"><a name="l00541"></a><span class="lineno">  541</span>&#160;</div>
<div class="line"><a name="l00542"></a><span class="lineno">  542</span>&#160;        <span class="keywordflow">return</span> bodySize+1+<span class="keyword">sizeof</span>(uint32);</div>
<div class="line"><a name="l00543"></a><span class="lineno">  543</span>&#160;    }</div>
<div class="line"><a name="l00544"></a><span class="lineno">  544</span>&#160;</div>
<div class="line"><a name="l00545"></a><span class="lineno">  545</span>&#160;};</div>
<div class="line"><a name="l00546"></a><span class="lineno">  546</span>&#160;</div>
<div class="line"><a name="l00547"></a><span class="lineno">  547</span>&#160;</div>
<div class="line"><a name="l00548"></a><span class="lineno">  548</span>&#160;</div>
<div class="line"><a name="l00549"></a><span class="lineno">  549</span>&#160;<span class="preprocessor">#endif </span><span class="comment">/* TIGLCOMMUNICATIONMUTATIONMESSAGE_HPP_ */</span><span class="preprocessor"></span></div>
<div class="ttc" id="classMutationMessage_html_a8650ccd700d60a94b9ebde4fb1ad37aa"><div class="ttname"><a href="classMutationMessage.html#a8650ccd700d60a94b9ebde4fb1ad37aa">TIGLMutationMessage::getDstVertex</a></div><div class="ttdeci">bool getDstVertex(ID_TYPE *targetVertex)</div><div class="ttdoc">returns destination vertex </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:494</div></div>
<div class="ttc" id="classMutationMessage_html_aef31235623cbd56d1486f3ec62ae53fb"><div class="ttname"><a href="classMutationMessage.html#aef31235623cbd56d1486f3ec62ae53fb">TIGLMutationMessage::readMigrateVertexMessage</a></div><div class="ttdeci">bool readMigrateVertexMessage(CVertex *pVertex)</div><div class="ttdoc">reading the ADD_VERTEX </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:418</div></div>
<div class="ttc" id="classMutationMessage_html"><div class="ttname"><a href="classMutationMessage.html">TIGLMutationMessage</a></div><div class="ttdoc">Mutation message class definition. </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:53</div></div>
<div class="ttc" id="classMutationMessage_html_a3f69431dcddd6218b390b362670f2b64"><div class="ttname"><a href="classMutationMessage.html#a3f69431dcddd6218b390b362670f2b64">TIGLMutationMessage::pack</a></div><div class="ttdeci">uint32 pack(byte *buf)</div><div class="ttdoc">packing the mutation message into bytes the packed message contains the message code and the message ...</div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:512</div></div>
<div class="ttc" id="classMutationMessage_html_a1fce3cb22d79b08b2af417017ded07da"><div class="ttname"><a href="classMutationMessage.html#a1fce3cb22d79b08b2af417017ded07da">TIGLMutationMessage::otherDevice</a></div><div class="ttdeci">uint32 otherDevice</div><div class="ttdoc">the destination device </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:112</div></div>
<div class="ttc" id="classMutationMessage_html_a1880c427af4deba4718a4d75f2f6047d"><div class="ttname"><a href="classMutationMessage.html#a1880c427af4deba4718a4d75f2f6047d">TIGLMutationMessage::getSizeInBytes</a></div><div class="ttdeci">uint32 getSizeInBytes()</div><div class="ttdoc">reading the variable-size message body </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:487</div></div>
<div class="ttc" id="classMutationMessage_html_adbddbb20325522d31da70a102fc1511e"><div class="ttname"><a href="classMutationMessage.html#adbddbb20325522d31da70a102fc1511e">TIGLMutationMessage::getDstDev</a></div><div class="ttdeci">int32 getDstDev()</div><div class="ttdoc">reading teh destination device </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:490</div></div>
<div class="ttc" id="classMutationMessage_html_acdce3bb6d07d5b7fe2895c3858137a14"><div class="ttname"><a href="classMutationMessage.html#acdce3bb6d07d5b7fe2895c3858137a14">TIGLMutationMessage::messageCode</a></div><div class="ttdeci">MUTATION_MESSAGE_CODE messageCode</div><div class="ttdoc">code of the mutation message </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:108</div></div>
<div class="ttc" id="classMutationMessage_html_abbd3fa9e6726c2f833d1713a985affc4"><div class="ttname"><a href="classMutationMessage.html#abbd3fa9e6726c2f833d1713a985affc4">TIGLMutationMessage::readEmptyVertexMessage</a></div><div class="ttdeci">bool readEmptyVertexMessage(ID_TYPE *vertexId)</div><div class="ttdoc">reading the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:197</div></div>
<div class="ttc" id="classMutationMessage_html_a588b2459d4dd50217a6451af8802e88d"><div class="ttname"><a href="classMutationMessage.html#a588b2459d4dd50217a6451af8802e88d">TIGLMutationMessage::readRemoveEdgeMessage</a></div><div class="ttdeci">bool readRemoveEdgeMessage(ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</div><div class="ttdoc">reading the ADD/REMOVE_EDGE mutation message </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:168</div></div>
<div class="ttc" id="classMutationMessage_html_a40df23bd34b66d1ecdd91ca0da74b981"><div class="ttname"><a href="classMutationMessage.html#a40df23bd34b66d1ecdd91ca0da74b981">TIGLMutationMessage::prepareAddVertexMessage</a></div><div class="ttdeci">uint32 prepareAddVertexMessage(CVertex *vertex)</div><div class="ttdoc">preparing the ADD_VERTEX </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:212</div></div>
<div class="ttc" id="classMutationMessage_html_ac0c615f45fa618af2f2c82009a28b71a"><div class="ttname"><a href="classMutationMessage.html#ac0c615f45fa618af2f2c82009a28b71a">TIGLMutationMessage::unpack</a></div><div class="ttdeci">uint32 unpack(byte *buf)</div><div class="ttdoc">unpacking a mutation message to the object fields </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:531</div></div>
<div class="ttc" id="classMutationMessage_html_a75164a2782ad4b29499c870ed80bb9e8"><div class="ttname"><a href="classMutationMessage.html#a75164a2782ad4b29499c870ed80bb9e8">TIGLMutationMessage::prepareMigrateVertexMessage</a></div><div class="ttdeci">uint32 prepareMigrateVertexMessage(CVertex *vertex)</div><div class="ttdoc">preparing the MIGRATE_VERTEX </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:371</div></div>
<div class="ttc" id="classMutationMessage_html_acd878d994f3305730548ff6b37d72d89"><div class="ttname"><a href="classMutationMessage.html#acd878d994f3305730548ff6b37d72d89">TIGLMutationMessage::prepareEmptyVertexMessage</a></div><div class="ttdeci">uint32 prepareEmptyVertexMessage(ID_TYPE *vertexId)</div><div class="ttdoc">preparing the ADD_EMPTY_VERTEX or REMOVE_VERTEX mutation message </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:184</div></div>
<div class="ttc" id="classMutationMessage_html_a21f10b086de910f00d8d4466ff8d9478"><div class="ttname"><a href="classMutationMessage.html#a21f10b086de910f00d8d4466ff8d9478">TIGLMutationMessage::TIGLMutationMessage</a></div><div class="ttdeci">TIGLMutationMessage()</div><div class="ttdoc">constructor set the fields of the mutations message </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:65</div></div>
<div class="ttc" id="classMutationMessage_html_a4dd11e68c90db1b6c2752be8c723b128"><div class="ttname"><a href="classMutationMessage.html#a4dd11e68c90db1b6c2752be8c723b128">TIGLMutationMessage::prepareRemoveEdgeMessage</a></div><div class="ttdeci">uint32 prepareRemoveEdgeMessage(ID_TYPE *nbrVertex, ID_TYPE *targetVertex)</div><div class="ttdoc">preparing the REMOVE_OUT/IN_EDGE mutation message </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:153</div></div>
<div class="ttc" id="classMutationMessage_html_a2531f613fca0307804d1a4bf45e92cf5"><div class="ttname"><a href="classMutationMessage.html#a2531f613fca0307804d1a4bf45e92cf5">TIGLMutationMessage::getMessageCode</a></div><div class="ttdeci">MUTATION_MESSAGE_CODE getMessageCode()</div><div class="ttdoc">returns the mutation message code </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:484</div></div>
<div class="ttc" id="classMutationMessage_html_ad1fd34459df13e8162a4967d961b2cea"><div class="ttname"><a href="classMutationMessage.html#ad1fd34459df13e8162a4967d961b2cea">TIGLMutationMessage::prepareAddEdgeMessage</a></div><div class="ttdeci">uint32 prepareAddEdgeMessage(EdgeType *pEdge, ID_TYPE *targetVertex)</div><div class="ttdoc">preparing the ADD_OUT/IN_EDGE mutation message </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:121</div></div>
<div class="ttc" id="classMutationMessage_html_a1b6e1b5ce4c29e252a839bb7d28b2bc5"><div class="ttname"><a href="classMutationMessage.html#a1b6e1b5ce4c29e252a839bb7d28b2bc5">TIGLMutationMessage::readAddEdgeMessage</a></div><div class="ttdeci">bool readAddEdgeMessage(EdgeType *pEdge, ID_TYPE *targetVertex)</div><div class="ttdoc">reading the ADD/REMOVE_EDGE mutation message </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:135</div></div>
<div class="ttc" id="classMutationMessage_html_a85a9603c0995c954654db90b6e3c753d"><div class="ttname"><a href="classMutationMessage.html#a85a9603c0995c954654db90b6e3c753d">TIGLMutationMessage::readAddVertexMessage</a></div><div class="ttdeci">bool readAddVertexMessage(CVertex *pVertex)</div><div class="ttdoc">reading the ADD_VERTEX </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:274</div></div>
<div class="ttc" id="classMutationMessage_html_aa873f4348060f3b98b4a6048f6b81983"><div class="ttname"><a href="classMutationMessage.html#aa873f4348060f3b98b4a6048f6b81983">TIGLMutationMessage::messageBody</a></div><div class="ttdeci">vector&lt; byte &gt; messageBody</div><div class="ttdoc">message body in bytes </div><div class="ttdef"><b>Definition:</b> tiglCommunicationMutationMessage.hpp:110</div></div>
</div><!-- fragment --></div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Mon Oct 20 2014 16:19:13 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
